      program nx2as
c***** reads ILL .nxs file and converts to standard ascii format
c
c      uses dictionary to find parameters
c      D33nxs.sfl for D33
c      D22nxs.sfl for D22
c      these contain dataset absolute names, par-location, multiplier, def. value
c      if found in the current workdir it is used, otherwise file from
c      SAS_DIR is used
c     the dictionary depends on SAS_INSTRUMENT
c     raw data sought fro SAS_INSTRUMENT
c     ascii data written into SAS_CACHE directory for reuse by olde programs
c
c      Ron Ghosh, Epsom September 2012
c
c
      parameter (NXYT=100*128*256)
      integer idon(100*256*128)
      real par(128)
      integer i0(256)
      common/h5work/iv(NXYT)
      common/maxarr/ntitl,npar,nparx,ndx
      common/sasmed/medpar(156)
      common/sasnxc/version
      common/nx2asc/cashnam,pathnam
c***** tests sasas for nxs files
      character nomexp*10,ddate*20
      character*1 text(512)
      character lin*80
      character fname*6,inst*4,version*80,cmd*100
      character cashnam*100,pathnam*100,fullnam*100,argf*20
      integer ifound,itran,iraw
      logical found
      data i0/256*0/
      itran=0
      ifound=0
      iraw=0
      inst=' '
      fullnam=' '
      cashnam=' '
      pathnam=' '
      cmd=' '
      call getenv('SAS_DATA_PATH',pathnam)
      if(pathnam.eq.' ') stop 'SAS_DATA_PATH not set'
      call getenv('SAS_CACHE',cashnam)
      if(cashnam.eq.' ') 
     1 stop 'nx2as needs SAS_CACHE - not set'
c***** look for cache directory
      lc=len_trim(cashnam)
      inquire(file=cashnam(1:lc),exist=found)
      if(found) go to 8
c      write(*,*) ' exists ',found
      cmd='mkdir '//cashnam(1:lc)
      call system(cmd)
      inquire(file=cashnam(1:lc),exist=found)
c      write(*,*)' exists now ',found)
      if(.not.found) 
     1write(*,*)' Cannot create cache directory ',cashnam(1:lc)
      if(.not.found) stop
8     call getenv('SAS_INSTRUMENT',inst)
      if(inst.eq.' ') stop 'SAS_INSTRUMENT not set'
      if(inst(1:1).eq.'d') inst(1:1)='D'
      narg=iargc()
      if(narg.lt.1) go to 5
      irst=0
      last=0
      call getarg(1,argf)
      argf(15:20)=' 0 0/'
      read(argf,*) irst
      call getarg(2,argf)
      argf(15:20)=' 0 0 /'
      read(argf,*) last
c      write(*,*)' irst, last',irst,last
      go to 19
5     write(6,6)
6     format(' nx2as - transcribes SAS NeXus data to ASCII file'/
     1' version 1.0, Ron Ghosh, Epsom, September 2012'//
     1' files are created in cache directory if not already found'//
     1' Give first and last run numbers to treat : '$)
      read(5,11) lin
      lin(70:79)='0 0 0 0 /'
      read(lin,*) irst,last
19    if(irst.eq.0) stop 'nothing done'
      if(last.le.irst) last=irst
c      numor=34100
20    do 90 j=irst,last   
      iraw=iraw+1   
      numor=j
      write(fname,10) numor
10    format(I6.6)
      fullnam=cashnam(1:lc)//'/'//fname
      lf=lc+1+6
      inquire(file=fullnam(1:lf),exist=found)
c      if(found) stop ' ascii file output already exists '
      if(found) ifound=ifound+1
      if(narg.lt.1) write(*,*)' file ',fullnam(1:lf),':',found
      if(found) go to 90
      do i=1,512
      text(i)=' '
      end do
      ix=128
      iy=128
      call sasanx(ier,numor,nomexp,ddate,nt,text,np,par,nd,idon)
      if(ier.ne.0.and.narg.lt.1) write(*,*) ' Error reading ',numor
      if(ier.ne.0) go to 90
      isu=0
      do i=1,nd
       isu=isu+idon(i)
      end do
      if(isu.eq.0.and.narg.lt.1) 
     1write(*,*)' WARNING - 2D data all 0 - check DNNnxs.sfl file'
      if(nd.gt.ndx) call p3back(idon,iv,ix,iy)
      nd=ix*iy
      if(ier.ne.0.and.narg.lt.1) write(*,*) 'Run not found ',numor 
      if(ier.ne.0) go to 90
c***** write out as ascii file
      open(unit=1,file=fullnam(1:lf),status='unknown',err=99)
      write(1,15)
15    format(10('RRRRRRRR')) 
      iver=1
      itxt=1
      write(lin,22) numor,itxt,iver
22    format(2x,i6.6,9i8)
      write(1,11) lin
      write(lin,80) numor
80    format('From ',i6.6,'.nxs by sasnx - selection ')
      lin=lin(1:40)//version(1:40)

      write(1,11) lin
      write(1,13)
13    format(10('AAAAAAAA'))
      lin=' '
12    format(10i8)
      nc=80
      itxt=0
      write(lin,12) nc,itxt
      write(1,11) lin
      lin=inst//inst//'      '//ddate
      write(1,11) lin
11    format(a80)
c***** medpar block
      call iout(156,medpar)
      call aout(512,text)
      call fout(np,par)
      call iout(256,i0)
      write(1,16)
16    format(10('SSSSSSSS'))
c      write(*,*) ' number of data ',nd
      lin=' '
c****** for spectrum write ispec,nrest,ntot,nrun,itxt
      ispec=1
      nrest=0
      ntot=n
      nrun=1
      itxt=0
      write(lin,12) ispec,nrest,ntot,nrun,itxt
      write(1,11) lin
      
      call iout(nd,idon)
      close(unit=1)
      itran=itran+1
      if(narg.lt.1) write(*,*) 'Run ',numor,' encached '
90    continue
      if(narg.lt.1)
     1write(*,*)'Runs sought/in_cache/transcribed ',iraw,ifound,itran
      stop 
99    write(*,*) fullnam
      end
      subroutine iout(n,iv)
      integer iv(n)
      character lin*80,iii*80
      write(1,13) 
13    format(10('IIIIIIII'))
      lin=' '
      itxt=0
      write(lin,1) n,itxt
      write(1,11) lin
      lin=' '
      nrest=mod(n,10)
      nn=n-nrest
      write(1,1) (iv(i),i=1,nn)
1     format(10i8)
      write(lin,1) (iv(j),j=nn+1,n)
      write(1,11) lin
11    format(a)
      return
      end

      subroutine fout(n,v)
      real v(n)
      character lin*80
      write(1,13)
13    format(10('FFFFFFFF')) 
      lin=' '
      itxt=0
      write(lin,12) n,itxt
12    format(10i8)
      write(1,11) lin
      lin=' '
      nrest=mod(n,5)
      nn=n-nrest
      write(1,1) (v(i),i=1,nn)
1     format(5e16.5)
      write(lin,1) (v(j),j=nn+1,n)
      write(1,11) lin
11    format(a)
      return
      end
      subroutine aout(n,c)
      character*1 c(n)
      character lin*80
      write(1,13) 
13    format(10('AAAAAAAA'))
      lin=' '
      itxt=0
      write(lin,12) n,itxt
12    format(10i8)
      write(1,11) lin
      lin=' '
      nrest=mod(n,80)
      nn=n-nrest
      write(1,1) (c(i),i=1,nn)
1     format(80a1)
      write(lin,1) (c(j),j=nn+1,n)
      write(1,11) lin
11    format(a)
      return
      end

      subroutine p3back(iv,ivv,ix,iy)
c***** packs as 5x5 TOF frames of 64x64 pixels
      integer iv(320,320),ivv(100,128,256)
      integer ivvv(25,128,64),iww(25,64,64)
      
c***** pack back starting at short wavelengths top left hand corner
      call p25(ivv)
c**** fill in vvv
      call p256(ivvv,ivv)
c**** reduce and transpose
      call p128(iww,ivvv)
c**** set up 25 images
      call pim(iv,iww)
      ix=320
      iy=320
      return
      end
      subroutine p25(iv)
c***** reduce from 100 to 25 time channels
      parameter (nxy=100*128*256)
      integer iv(nxy)
      n=0
      do i=1,nxy-3,4
      n=n+1
      isum=iv(i)+iv(i+1)+iv(i+2)+iv(i+3)
      iv(n)=isum
      end do
      return
      end
      subroutine p256(ivv,ivvv)
c***** reduce x to 64
      integer ivv(25,128,64),ivvv(25,128,256)
      do it=1,25
      do iy=1,128
      ixx=1
      do ix=1,64
      is=ivvv(it,iy,ixx)+ivvv(it,iy,ixx+1)+
     1ivvv(it,iy,ixx+2)+ivvv(it,iy,ixx+3)
      ivv(it,iy,ix)=is
      ixx=ixx+4
      end do      
      end do
      end do
      return
      end
      subroutine p128(ivv,ivvv)
c**** reduce y from 128 to 64 AND transpose
      integer ivv(25,64,64),ivvv(25,128,64)
      do it=1,25
      do ix=1,64
      iyy=1
      do iy=1,64
      is=ivvv(it,iyy,ix)+ivvv(it,iyy+1,ix)
      iyy=iyy+2
      ivv(it,ix,iy)=is
      end do
      end do
      end do
      return
      end
      subroutine pim(iv,iw)
c**** transfers images to 320x320 as 25 64x64 sets
      integer iv(320,320),iw(25,64,64)
c**** v is (ix,iy) in pixels, wm is (time,ix,iy)
c***** start bottom lh corner
      n=0
      ixx=4*64
      iyy=0
      do it=25,1,-1
      do iy=1,64
      do ix=1,64
      n=n+1
      iv(ixx+ix,iyy+iy)=iw(it,ix,iy)
      end do
      end do
      ixx=ixx-64
      if(ixx.lt.0) iyy=iyy+64
      if(ixx.lt.0) ixx=4*64
      end do
      return
      end
